
;Hyperion II. intro

;This is the first ever complete song made in the experimental version
;of TLCPlay (V0.??)
;Now raped to this new version of the player (V0.99?)
;Still no license crap
;At the moment, you can do whatever you want with this source. This song was
;originally composed by Matt Gray, (C) 1988. All other stuff by
;Levente Hrsfalvi, 2001
;
;TLCPlay will probably be released under GPL.
;
;You can recompile the source using Table Driven Assembler 3.0.1 or later
;and ComLink V0.98 (or later, if there will be any).
;

         .module song

;#define ffskip                              ;First frame skip - if enabled

#define song
         *= $1800                           ;Driver start addy
#include driver.asm                         ;Driver routine for first-test
#include songdef.asm                        ;Command definitions and the like
         *= $0ffe                           ;Load address
         .word *+2
;         *= $1000                           ;Player start
#include tlcplay.asm                        ;The player itselves...


;Here start the sounds.

;
; --- Sound definitions ---
;
defs

silent   snddef(aidle,sidle,vidle)
kp       snddef(akeep,skeep,vkeep)
intr1    snddef(aidle,intr1s,intr1v)
out      snddef(aidle,out1s,out1v)
bass1    snddef(bassa,sidle,bassv)
sol1     snddef(sol1a,sidle,sol1v)
sol2     snddef(aidle,sol2s,sol1v)
sol2v    snddef(aidle,sol2vs,sol1v)
sol3     snddef(aidle,sol3s,sol1v)
sol3f    snddef(aidle,sol3fs,sol1v)
sol4     snddef(aidle,sol4s,sol1v)
sol5     snddef(sol5a,sidle,sol1v)
bont1    snddef(bont1a,sidle,sol1v)
bont2    snddef(bont2a,sidle,sol1v)
bont3    snddef(bont3a,sidle,sol1v)
chrd1    snddef(chrd1a,sidle,vdef)
chrd2    snddef(chrd2a,sidle,vdef)
snare    snddef(snra,sidle,snrv)

;Don't touch this
defe
sounds   = defe-defs
        .org $ + (2*sounds)
arp      = defs
slp      = defs + sounds
vop      = defs + (sounds*2)
;

;
; --- Arpeggio effect program ---
;
ars
         ar(0,0)                            ;- Pos 0 is not useable.
aidle    ar(1,0)
         astop                              ;- For idle 'emulation'.

bassa    ar($81,$80|$50)
;         ar(0,0)
bassl    ar($41,15)
         ar($41,-15)
         ajmp(bassl)

sol1a    ar($41,-1)
         ar($41,0)
         ar($41,1)
         ar($41,0)
         ar($41,-1)
         ar($41,-2)
         ajmp(sol1a)

sol5a    ar($81,$44)
sol5l    ar(4,0)
         ar($81,$44)
         ar(4,0)
         ar($81,$44)
         ajmp(sol5l)
;dcac
bont1a   ar($81,$44)
         ar(4,5)
         ar($81,$44)
         ar(4,3)
         ar($81,$44)
         ar(4,0)
         ar($81,$44)
         ar(4,3)
         ajmp(bont1a)
;feca
bont2a   ar($81,$44)
         ar(4,8)
         ar($81,$44)
         ar(4,7)
         ar($81,$44)
         ar(4,3)
         ar($81,$44)
         ar(4,0)
         ajmp(bont2a)
;cagfdcac
bont3a   ar($81,$44)
         ar(4,15)
         ar($81,$44)
         ar(4,12)
         ar($81,$44)
         ar(4,10)
         ar($81,$44)
         ar(4,8)
         ar($81,$44)
         ar(4,5)
         ar($81,$44)
         ar(4,3)
         ar($81,$44)
         ar(4,0)
         ar($81,$44)
         ar(4,3)
         ajmp(bont3a)

chrd1a   ar(1,0)
         ar(1,7)
         ar(1,12)
         ajmp(chrd1a)

chrd2a   ar(1,0)
         ar(1,8)
         ar(1,12)
         ajmp(chrd2a)

snra     ar($81,$80|$6c)
         ar($81,10)
         ar($81,$80|$50)
snrl     ar($81,$80|$40)
         ar($81,5)
         astop

;Don't touch this
are
arlen    = are - ars
         .org $+arlen
ar0      = ars
ar1      = are


;
;
; --- Slide effect program ---
;
sls
         sl(0,0)                            ;- Pos 0 is not useable.
sidle    sl($81,0)
         sstop                              ;- For idle 'emulation'.

intr1s   sl(1,2)
         sl(2,0)
         sjmp(intr1s)

out1s    sl(1,-1)
         sl(1,0)
         sjmp(out1s)

sol2s    sl(2,0)
         sl(1,1)
         sjmp(sol2s)

sol2vs   sl(1,1)
         sjmp(sol2vs)

sol3s    sl(1,1)
         sl(2,0)
         sjmp(sol3s)

sol3fs   sl(6,0)
         sl(1,1)
         sjmp(sol3fs)

sol4s    sl(1,-1)
         sjmp(sol4s)

sol5s    sl($81,2)
sol5sl   sl(4,-1)
         sl($81,-1)
         sl(4,1)
         sl($81,1)
         sjmp(sol5sl)

;Don't touch this
sle
sllen    = sle - sls
         .org $+sllen
sl0      = sls
sl1      = sle

;
;
; --- Volume effect program ---
;
vos
         vo(0,0)                            ;- Pos 0 is not useable.
vidle    vo(1,$84)
         vstop                              ;- For idle 'emulation'.

vdef     vo(1,$08)
         vstop

intr1v   vo(80,0)
         vo(80,2)
         vo(80,4)
         vo(1,6)
         vstop

out1v    vo(80,8)
         vo(80,6)
         vo(80,4)
         vo(80,2)
         vo(1,0)
         vstop

bassv    vo(1,8)
         vstop

sol1v    vo(3,8)
         vo(7,6)
         vjmp(sol1v)

snrv     vo(2,8)
         vo(4,4)
         vo(1,$84)
         vstop

;Don't touch this
voe
volen    = voe - vos
         .org $+volen
vo0      = vos
vo1      = voe

; --- Track arrangement
;

trk0
         trans(1)
         sct(intro1)
         sct(empty)
         sct(empty)
         sct(solo1)
         sct(solo1)
         sct(solo2)
         sct(solo3)
         sct(solo4)
         sct(solo5)
         sct(bont1s)
         sct(bont2s)
         sct(solo7)
         sct(solo8)
         sct(solo7)
         sct(solo8)
         sct(solo2)
         sct(solo3)
         sct(solo4)
         sct(solo5)
         sct(chord)
         sct(chord)
         sct(bont1s)
         sct(bont2s)
         sct(bont3s)
         sct(bont3s)
         sct(solo6)
         sct(solo7)
         trans(13)
         sct(endx)
         trans(1)
         sct(empty)
         sct(empty)
         t0jmp(trk0+1)

trk1
         trans(1)
         sct(intro2)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(bass)
         sct(endx)
         sct(empty)
         sct(empty)
         t1jmp(trk1+1)

; --- Sector address table ---
;
sctas

empty    sctdef(empsc)
intro1   sctdef(intro1_s)
intro2   sctdef(intro2_s)
bass     sctdef(bass_s)
solo1    sctdef(solo1_s)
solo2    sctdef(solo2_s)
solo3    sctdef(solo3_s)
solo4    sctdef(solo4_s)
solo5    sctdef(solo5_s)
solo6    sctdef(solo6_s)
solo7    sctdef(solo7_s)
solo8    sctdef(solo8_s)
bont1s   sctdef(bont1_s)
bont2s   sctdef(bont2_s)
bont3s   sctdef(bont3_s)
chord    sctdef(chord_s)
endx     sctdef(endx_s)

;Don't touch this
sctae
sctalen = sctae-sctas
        .org $+sctalen
sctaddl = sctas
sctaddh = sctae


; --- Sector arrangement ---
;

empsc    snd(silent)
         dur(40)
         C0
         C0
         C0
         C0
         C0
         C0
         C0
         C0
         fin

intro1_s snd(intr1)
         dur(40)
         D0
         keep
         keep
         keep
         keep
         keep
         keep
         keep
         fin

intro2_s snd(snare)
         dur(40)
         C0
         dur(10)
         C0
         dur(30)
         C0
         dur(40)
         C0
         dur(10)
         C0
         dur(30)
         C0
         dur(40)
         C0
         dur(10)
         C0
         dur(30)
         C0
         dur(40)
         C0
         dur(10)
         C0
         C0
         C0
         C0
         fin

bass_s   snd(bass1)
         dur(10)
         D0
         D0
         snd(snare)
         C0
         snd(bass1)
         D0
         D0
         D0
         snd(snare)
         C0
         snd(bass1)
         dur(05)
         C0
         C#0
         dur(10)
         D0
         D0
         snd(snare)
         C0
         snd(bass1)
         D0
         D0
         D0
         snd(snare)
         C0
         snd(bass1)
         dur(05)
         G0
         F#0
         dur(10)
         F0
         F0
         snd(snare)
         C0
         snd(bass1)
         F0
         F0
         F0
         snd(snare)
         C0
         snd(bass1)
         dur(05)
         F0
         F#0
         dur(10)
         G0
         G0
         snd(snare)
         C0
         snd(bass1)
         G0
         G0
         G0
         snd(snare)
         C0
         snd(bass1)
         dur(05)
         C1
         B0
         fin


solo1_s  snd(sol1)
         dur(10)
         off
         D2
         dur(20)
         D2
         off
         dur(15)
         D2
         dur(5)
         off
         dur(10)
         off
         D2
         dur(20)
         D2
         off
         dur(15)
         D2
         dur(5)
         off
         dur(10)
         off
         F2
         dur(20)
         F2
         off
         dur(15)
         F2
         dur(5)
         off
         dur(10)
         off
         D2
         dur(20)
         D2
         off
         snd(sol2)
         dur(20)
         C2
         fin

solo2_s  snd(sol1)
         dur(20)
         C2
         snd(sol3)
         dur(20)
         C2
         dur(40)
         keep
         snd(sol1)
         D2
         D2
         D2
         D2
         D2
         D2
         fin

solo3_s  snd(sol4)
         dur(40)
         D2
         keep
         keep
         keep
         snd(sol1)
         C2
         keep
         dur(60)
         B1
         snd(sol2v)
         dur(20)
         B1
         fin

solo4_s  snd(sol1)
         dur(40)
         D2
         D2
         D3
         D2
         D3
         D2
         D3
         D2
         fin

solo5_s  snd(sol5)
         dur(40)
         D3
         D3
         D3
         D3
         D3
         D3
         D3
         D3
         fin

solo6_s  snd(sol3f)
         dur(40)
         C3
         keep
         snd(sol1)
         D3
         D3
         D3
         D3
         snd(sol4)
         D3
         keep
         fin

solo7_s  snd(sol1)
         dur(40)
         A2
         dur(30)
         B2
         dur(10)
         G2
         dur(60)
         A2
         dur(20)
         D3
         dur(30)
         C3
         B2
         dur(20)
         A2
         dur(30)
         F2
         E2
         dur(20)
         C2
         fin

solo8_s  snd(sol1)
         dur(40)
         D2
         D2
         D2
         D2
         snd(sol4)
         D2
         keep
         snd(sol2)
         C2
         keep
         fin

bont1_s  snd(bont1)
         dur(40)
         A1
         A1
         A1
         A1
         A1
         A1
         A1
         A1
         fin

bont2_s  snd(bont2)
         dur(40)
         A1
         A1
         A1
         A1
         A1
         A1
         A1
         A1
         fin

bont3_s  snd(bont3)
         dur(40)
         A1
         A1
         A1
         A1
         A1
         A1
         A1
         A1
         fin

chord_s  snd(chrd1)
         dur(40)
         D2
         snd(kp)
         D2
         D2
         D2
         C2
         C2
         snd(chrd2)
         B1
         keep
         fin
         .end

endx_s   snd(out)
         dur(40)
         D2
         keep
         keep
         keep
         keep
         keep
         keep
         keep
         fin

         .end
